OILS / _gen / bin / text_files.cc View on Github | oilshell.org

1799 lines, 151 significant
1
2#include "cpp/embedded_file.h"
3
4namespace embedded_file {
5GLOBAL_STR(gStr0, R"zZXx(
6 Errors
7 <a class="group-link" href="chap-errors.html">errors</a>
8
9
10 [UTF8] err-utf8-encode err-utf8-decode
11 [J8 String] err-j8-str-encode err-j8-str-decode
12 [J8 Lines] err-j8-lines-encode err-j8-lines-decode
13 [JSON] err-json-encode err-json-decode
14 [JSON8] err-json8-encode err-json8-decode
15)zZXx");
16
17GLOBAL_STR(gStr1, R"zZXx(
18
19 Front End <a class="group-link" href="chap-front-end.html">front-end</a>
20
21
22 [Lexing] ascii-whitespace [ \t\r\n]
23 ascii-control-chars
24)zZXx");
25
26GLOBAL_STR(gStr2, R"zZXx(
27 J8 Notation
28 <a class="group-link" href="chap-j8.html">j8</a>
29
30
31 [J8 Strings] json-string "hi"
32 json-escape \" \\ \u1234
33 surrogate-pair \ud83e\udd26
34 j8-escape \' \u{1f926} \yff
35 u-prefix u'hi'
36 b-prefix b'hi'
37 no-prefix 'hi'
38 [J8 Lines] unquoted-line
39 [JSON8] json8-num json8-str
40 X json8-list X json8-dict
41 json8-comment
42 [TSV8] column-attrs column-types
43)zZXx");
44
45GLOBAL_STR(gStr3, R"zZXx(Usage: help TOPIC?
46
47Examples:
48
49 help # this help
50 help echo # help on the 'echo' builtin
51 help command-sub # help on command sub $(date)
52
53 help oils-usage # identical to oils-for-unix --help
54 help osh-usage # osh --help
55 help ysh-usage # ysh --help
56)zZXx");
57
58GLOBAL_STR(gStr4, R"zZXx(bin/oils-for-unix is an executable that contains OSH, YSH, and more.
59
60Usage: oils-for-unix MAIN_NAME ARG*
61 MAIN_NAME ARG*
62
63It behaves like busybox. The command name can be passed as the first argument:
64
65 oils-for-unix ysh -c 'echo hi'
66
67More commonly, it's invoked through a symlink like 'ysh', which causes it to
68behave like that command:
69
70 ysh -c 'echo hi'
71)zZXx");
72
73GLOBAL_STR(gStr5, R"zZXx(
74 Builtin Commands <a class="group-link" href="chap-builtin-cmd.html">builtin-cmd</a>
75
76
77 [I/O] read echo printf
78 readarray mapfile
79 [Run Code] source . eval trap
80 [Set Options] set shopt
81 [Working Dir] cd pwd pushd popd dirs
82 [Completion] complete compgen compopt compadjust compexport
83 [Shell Process] exec X logout
84 umask ulimit times
85 [Child Process] jobs wait
86 fg X bg X kill X disown
87 [External] test [ getopts
88 [Introspection] help hash cmd/type X caller
89 [Word Lookup] command builtin
90 [Interactive] alias unalias history X fc X bind
91X [Unsupported] enable
92)zZXx");
93
94GLOBAL_STR(gStr6, R"zZXx(The reference is divided in to "chapters", each of which has its own table of
95contents. Type:
96
97 help osh-$CHAPTER
98
99Where $CHAPTER is one of:
100
101 front-end
102 command-lang
103 osh-assign
104 word-lang
105 mini-lang
106 builtin-cmd
107 option
108 special-var
109 plugin
110
111Example:
112
113 help osh-word-lang
114)zZXx");
115
116GLOBAL_STR(gStr7, R"zZXx(
117 Command Language <a class="group-link" href="chap-cmd-lang.html">cmd-lang</a>
118
119
120 [Commands] simple-command semicolon ;
121 [Conditional] case if dbracket [[
122 true false colon :
123 bang ! and && or ||
124 [Iteration] while until for for-expr-sh ((
125 [Control Flow] break continue return exit
126 [Grouping] sh-func sh-block { subshell (
127 [Concurrency] pipe | X pipe-amp |& ampersand &
128 [Redirects] redir-file > >> >| < <> not impl: &>
129 redir-desc >& <&
130 here-doc << <<- <<<
131 [Other Command] dparen (( time X coproc X select
132)zZXx");
133
134GLOBAL_STR(gStr8, R"zZXx(
135 Front End <a class="group-link" href="chap-front-end.html">front-end</a>
136
137
138 [Usage] oils-usage osh-usage config
139 startup line-editing exit-codes
140 [Lexing] comment # line-continuation \ ascii-whitespace [ \t\r\n]
141)zZXx");
142
143GLOBAL_STR(gStr9, R"zZXx(
144 Other Mini Languages <a class="group-link" href="chap-mini-lang.html">mini-lang</a>
145
146
147 [Arithmetic] arith-context Where legacy arithmetic is allowed
148 sh-numbers 0xFF 0755 etc.
149 sh-arith 1 + 2*3 a *= 2
150 sh-logical !a && b
151 sh-bitwise ~a ^ b
152 [Boolean] bool-expr [[ ! $x && $y || $z ]]
153 test ! $x -a $y -o $z
154 bool-infix $a -nt $b $x == $y
155 bool-path -d /etc
156 bool-str -n foo -z ''
157 bool-other -o errexit -v name[index]
158 [Patterns] glob-pat *.py
159 extglob ,(*.py|*.sh)
160 regex [[ foo =~ [a-z]+ ]]
161 [Other Sublang] braces {alice,bob}@example.com
162 histsub !$ !! !n
163 char-escapes \t \c \x00 \u03bc
164)zZXx");
165
166GLOBAL_STR(gStr10, R"zZXx(
167 Global Shell Options <a class="group-link" href="chap-option.html">option</a>
168
169
170 [Errors] nounset -u errexit -e inherit_errexit pipefail
171 [Globbing] noglob -f nullglob failglob X dotglob
172 dashglob (true)
173 [Debugging] xtrace X verbose X extdebug
174 [Interactive] emacs vi
175 [Other POSIX] X noclobber
176 [Compat] eval_unsafe_arith ignore_flags_not_impl
177)zZXx");
178
179GLOBAL_STR(gStr11, R"zZXx(
180 Assignments and Expressions <a class="group-link" href="chap-osh-assign.html">osh-assign</a>
181
182
183 [Literals] sh-array array=(a b c) array[1]=B "${a[@]}"
184 sh-assoc assoc=(['a']=1 ['b']=2) assoc['x']=b
185 [Operators] sh-assign str='xyz'
186 sh-append str+='abc'
187 [Builtins] local readonly export unset shift
188 declare typeset X let
189)zZXx");
190
191GLOBAL_STR(gStr12, R"zZXx(
192 Plugins and Hooks <a class="group-link" href="chap-plugin.html">plugin</a>
193
194
195 [Signals] SIGTERM SIGINT SIGQUIT
196 SIGTTIN SIGTTOU SIGWINCH
197 [Traps] DEBUG ERR EXIT X RETURN
198 [Words] PS1 X PS2 X PS3 PS4
199 [Completion] complete
200 [Other Plugin] PROMPT_COMMAND X command_not_found
201)zZXx");
202
203GLOBAL_STR(gStr13, R"zZXx(
204 Special Variables <a class="group-link" href="chap-special-var.html">special-var</a>
205
206
207 [POSIX Special] $@ $* $# $? $- $$ $! $0 $9
208 [Shell Vars] IFS X LANG X GLOBIGNORE
209 [Shell Options] SHELLOPTS X BASHOPTS
210 [Other Env] HOME PATH
211 [Other Special] BASH_REMATCH @PIPESTATUS
212 [Platform] HOSTNAME OSTYPE
213 [Call Stack] @BASH_SOURCE @FUNCNAME @BASH_LINENO
214 X @BASH_ARGV X @BASH_ARGC
215 [Tracing] LINENO
216 [Process State] UID EUID PPID X BASHPID
217X [Process Stack] BASH_SUBSHELL SHLVL
218X [Shell State] BASH_CMDS @DIRSTACK
219 [Completion] @COMP_WORDS COMP_CWORD COMP_LINE COMP_POINT
220 COMP_WORDBREAKS @COMPREPLY X COMP_KEY
221 X COMP_TYPE COMP_ARGV
222 [History] HISTFILE
223 [cd] PWD OLDPWD X CDPATH
224 [getopts] OPTIND OPTARG X OPTERR
225 [read] REPLY
226 [Functions] X RANDOM SECONDS
227 [Oils VM] OILS_VERSION LIB_OSH
228)zZXx");
229
230GLOBAL_STR(gStr14, R"zZXx(
231 Standard Library <a class="group-link" href="chap-stdlib.html">stdlib</a>
232
233
234 [two] log die
235 [no-quotes] nq-run nq-capture nq-capture-2 nq-assert
236 [bash-strict]
237 [task-five]
238)zZXx");
239
240GLOBAL_STR(gStr15, R"zZXx(
241 OSH Types <a class="group-link" href="chap-type-method.html">type-method</a>
242
243
244 [OSH] BashArray BashAssoc
245)zZXx");
246
247GLOBAL_STR(gStr16, R"zZXx(bin/osh is compatible with POSIX shell, bash, and other shells.
248
249Usage: osh FLAG* SCRIPT ARG*
250 osh FLAG* -c COMMAND ARG*
251 osh FLAG*
252
253The command line accepted by `bin/osh` is compatible with /bin/sh and bash.
254
255 osh -c 'echo hi'
256 osh myscript.sh
257 echo 'echo hi' | osh
258
259It also has a few enhancements:
260
261 osh -n -c 'hello' # pretty-print the AST
262 osh --ast-format text -n -c 'hello' # print it full
263
264osh accepts POSIX sh flags, with these additions:
265
266 -n parse the program but don't execute it. Print the AST.
267 --ast-format what format the AST should be in
268)zZXx");
269
270GLOBAL_STR(gStr17, R"zZXx(
271 Word Language <a class="group-link" href="chap-word-lang.html">word-lang</a>
272
273
274 [Quotes] osh-string 'abc' $'line\n' "$var"
275 [Substitutions] command-sub $(command) `command`
276 var-sub ${var} $0 $9
277 arith-sub $((1 + 2))
278 tilde-sub ~/src
279 proc-sub diff <(sort L.txt) <(sort R.txt)
280 [Var Ops] op-test ${x:-default}
281 op-strip ${x%%suffix} etc.
282 op-replace ${x//y/z}
283 op-index ${a[i+1}
284 op-slice ${a[@]:0:1}
285 op-format ${x@P}
286)zZXx");
287
288GLOBAL_STR(gStr18, R"zZXx(
289 Builtin Commands <a class="group-link" href="chap-builtin-cmd.html">builtin-cmd</a>
290
291
292 [Memory] cmd/append Add elements to end of array
293 pp asdl cell X gc-stats line proc
294 [Handle Errors] error error 'failed' (status=2)
295 try Run with errexit, set _error
296 failed Test if _error.code !== 0
297 boolstatus Enforce 0 or 1 exit status
298 [Shell State] ysh-cd ysh-shopt compatible, and takes a block
299 shvar Temporary modify global settings
300 ctx Share and update a temporary "context"
301 push-registers Save registers like $?, PIPESTATUS
302 [Modules] runproc Run a proc; use as main entry point
303 module guard against duplicate 'source'
304 is-main false when sourcing a file
305 use change first word lookup
306 [I/O] ysh-read flags --all, -0
307 ysh-echo no -e -n with simple_echo
308 write Like echo, with --, --sep, --end
309 fork forkwait Replace & and (), and takes a block
310 fopen Open multiple streams, takes a block
311 X dbg Only thing that can be used in funcs
312 [Hay Config] hay haynode For DSLs and config files
313 [Completion] compadjust compexport
314 [Data Formats] json read write
315 json8 read write
316X [Testing] assert takes an expression
317)zZXx");
318
319GLOBAL_STR(gStr19, R"zZXx(
320 Builtin Functions <a class="group-link" href="chap-builtin-func.html">builtin-func</a>
321
322
323 [Values] len() func/type() X repeat()
324 [Conversions] bool() int() float() str() list() dict()
325 X runes() X encodeRunes()
326 X bytes() X encodeBytes()
327 [Str] X strcmp() X split() shSplit()
328 [List] join() any() all()
329 [Collections] X copy() X deepCopy()
330 [Word] glob() maybe()
331 [Math] abs() max() min() X round() sum()
332 [Serialize] toJson() fromJson()
333 toJson8() fromJson8()
334X [J8 Decode] J8.Bool() J8.Int() ...
335 [Pattern] _group() _start() _end()
336 [Introspection] shvarGet() getVar() evalExpr()
337 [Hay Config] parseHay() evalHay()
338X [Hashing] sha1dc() sha256()
339)zZXx");
340
341GLOBAL_STR(gStr20, R"zZXx(The reference is divided in to "chapters", each of which has its own table of
342contents. Type:
343
344 help ysh-$CHAPTER
345
346Where $CHAPTER is one of:
347
348 front-end
349 command-lang
350 expr-lang
351 word-lang
352 builtin-cmd
353 option
354 special-var
355 type-method
356 builtin-func
357
358Example:
359
360 help ysh-expr-lang
361)zZXx");
362
363GLOBAL_STR(gStr21, R"zZXx(
364 Command Language <a class="group-link" href="chap-cmd-lang.html">cmd-lang</a>
365
366
367 [YSH Simple] typed-arg json write (x)
368 lazy-expr-arg assert [42 === x]
369 block-arg cd /tmp { echo $PWD }; cd /tmp (; ; blockexpr)
370 [YSH Cond] ysh-case case (x) { *.py { echo 'python' } }
371 ysh-if if (x > 0) { echo }
372 [YSH Iter] ysh-while while (x > 0) { echo }
373 ysh-for for i, item in (mylist) { echo }
374)zZXx");
375
376GLOBAL_STR(gStr22, R"zZXx(
377 Expression Language and Assignments <a class="group-link" href="chap-expr-lang.html">expr-lang</a>
378
379
380 [Assignment] assign =
381 aug-assign += -= *= /= **= //= %=
382 &= |= ^= <<= >>=
383 [Literals] atom-literal true false null
384 int-literal 42 65_536 0xFF 0o755 0b10
385 float-lit 3.14 1.5e-10
386 X num-suffix 42 K Ki M Mi G Gi T Ti / ms us
387 ysh-string "x is $x" $"x is $x" r'[a-z]\n'
388 u'line\n' b'byte \yff'
389 triple-quoted """ $""" r''' u''' b'''
390 str-template ^"$a and $b" for Str::replace()
391 list-literal ['one', 'two', 3] :| unquoted words |
392 dict-literal {name: 'bob'} {a, b}
393 range 1 .. n+1
394 block-expr ^(echo $PWD)
395 expr-literal ^[1 + 2*3]
396 X expr-sub $[myobj]
397 X expr-splice @[myobj]
398 [Operators] op-precedence Like Python
399 concat s1 ++ s2, L1 ++ L2
400 ysh-equals === !== ~== is, is not
401 ysh-in in, not in
402 ysh-compare < <= > >= (numbers only)
403 ysh-logical not and or
404 ysh-arith + - * / // % **
405 ysh-bitwise ~ & | ^ << >>
406 ysh-ternary '+' if x >= 0 else '-'
407 ysh-index s[0] mylist[3] mydict['key']
408 ysh-attr mydict.key
409 ysh-slice a[1:-1] s[1:-1]
410 func-call f(x, y; ...named)
411 thin-arrow mylist->pop()
412 fat-arrow mystr => startsWith('prefix')
413 match-ops ~ !~ ~~ !~~
414 [Eggex] re-literal / d+ ; re-flags ; ERE /
415 re-primitive %zero 'sq'
416 class-literal [c a-z 'abc' @str_var \\ \xFF \u0100]
417 named-class dot digit space word d s w
418 re-repeat d? d* d+ d{3} d{2,4}
419 re-compound seq1 seq2 alt1|alt2 (expr1 expr2)
420 re-capture <capture d+ as name: int>
421 re-splice Subpattern @subpattern
422 re-flags reg_icase reg_newline
423 X re-multiline ///
424)zZXx");
425
426GLOBAL_STR(gStr23, R"zZXx(
427 Front End <a class="group-link" href="chap-front-end.html">front-end</a>
428
429
430 [Usage] oils-usage ysh-usage
431 [Lexing] ascii-whitespace [ \t\r\n]
432 doc-comment ### multiline-command ...
433 [Tools] cat-em
434)zZXx");
435
436GLOBAL_STR(gStr24, R"zZXx(
437 Other Mini Languages <a class="group-link" href="chap-mini-lang.html">mini-lang</a>
438
439
440 [Patterns] glob-pat *.py
441 [Other Sublang] braces {alice,bob}@example.com
442)zZXx");
443
444GLOBAL_STR(gStr25, R"zZXx(
445 Global Shell Options <a class="group-link" href="chap-option.html">option</a>
446
447
448 [Groups] strict:all ysh:upgrade ysh:all
449 [YSH Details] opts-redefine opts-internal
450)zZXx");
451
452GLOBAL_STR(gStr26, R"zZXx(
453 Plugins and Hooks <a class="group-link" href="chap-plugin.html">plugin</a>
454
455
456 [YSH] renderPrompt()
457)zZXx");
458
459GLOBAL_STR(gStr27, R"zZXx(
460 Special Variables <a class="group-link" href="chap-special-var.html">special-var</a>
461
462
463 [YSH Vars] ARGV X ENV X _ESCAPE
464 _this_dir
465 [YSH Status] _error
466 _pipeline_status _process_sub_status
467 [YSH Tracing] SHX_indent SHX_punct SHX_pid_str
468 [YSH read] _reply
469 [History] YSH_HISTFILE
470 [Oils VM] OILS_VERSION
471 OILS_GC_THRESHOLD OILS_GC_ON_EXIT
472 OILS_GC_STATS OILS_GC_STATS_FD
473)zZXx");
474
475GLOBAL_STR(gStr28, R"zZXx(
476 Standard Library<a class="group-link" href="chap-stdlib.html">stdlib</a>
477
478
479 [Args Parser] parser Parse command line arguments
480 flag
481 arg
482 rest
483 parseArgs()
484X [Testing] describe Test harness
485X [Lines] slurp-by combine adjacent lines into cells
486X [Awk] each-line --j8 --max-jobs (Str, Template, Block) - xargs
487 each-row --max-jobs (Str, Template, Block) - xargs
488 each-word xargs-like splitting, similar to IFS too
489 split-by (str=\n, ifs=':', pattern=/s+/)
490 if-split-by
491 chop alias for split-by (pattern=/s+/)
492 must-match (/ <capture d+> </capture w+> /)
493 if-match
494X [Table Create] table --by-row --by-col (&place); construct/parse a table
495 table/cols cols name age - cols name:Str age:Int
496 types type Str Int
497 attr attr units - secs
498 row emit row
499 table cat concatenate TSV8
500 table align to ssv8
501 table tabify to tsv8
502 table header (cols = :|name age|, types = :|Str Int|, units = :|- secs|)
503 table slice e.g. slice (1, -1) slice (5, 7)
504 table to-tsv lose type info, and error on \t in cells
505X [Table Ops] where subset of rows; dplyr filter()
506 pick subset of columns ('select' taken by shell)
507 mutate transmute [average = count / sum] - drop the ones that are used?
508 rename (bytes='bytes', path='filename')
509 group-by add a column with a group ID [ext]
510 sort-by sort by columns; dplyr arrange() [ext]
511 summary count, sum, histogram, any, all, reduce(), etc. [ext]
512)zZXx");
513
514GLOBAL_STR(gStr29, R"zZXx(
515 Types and Methods <a class="group-link" href="chap-type-method.html">type-method</a>
516
517
518 [Atom Types] Null Bool
519 [Number Types] Int Float
520 [Str] X find() replace()
521 trim() trimStart() trimEnd()
522 startsWith() endsWith()
523 upper() lower()
524 search() leftMatch()
525 [List] List/append() pop() extend() indexOf()
526 X insert() X remove() reverse()
527 [Dict] keys() values() X get() X erase()
528 X inc() X accum()
529 [Range]
530 [Eggex]
531 [Match] group() start() end()
532 X groups() X groupDict()
533 [Place] setValue()
534 [Code Types] Expr Command
535 BuiltinFunc BoundFunc
536X [Func] name() location() toJson()
537X [Proc] name() location() toJson()
538X [Module] name() filename()
539 [IO] X eval() X captureStdout()
540 promptVal()
541 X time() X strftime()
542 X glob()
543X [Guts] heapId()
544)zZXx");
545
546GLOBAL_STR(gStr30, R"zZXx(bin/ysh is the shell with data tYpes, influenced by pYthon, JavaScript, ...
547
548Usage: ysh FLAG* SCRIPT ARG*
549 ysh FLAG* -c COMMAND ARG*
550 ysh FLAG*
551
552`bin/ysh` is the same as `bin/osh` with a the `ysh:all` option group set. So
553`bin/ysh` also accepts shell flags.
554
555 ysh -c 'echo hi'
556 ysh myscript.ysh
557 echo 'echo hi' | ysh
558)zZXx");
559
560GLOBAL_STR(gStr31, R"zZXx(
561 Word Language <a class="group-link" href="chap-word-lang.html">word-lang</a>
562
563
564 [Quotes] ysh-string "x is $x" $"x is $x" r'[a-z]\n'
565 u'line\n' b'byte \yff'
566 triple-quoted """ $""" r''' u''' b'''
567 X tagged-str "<span id=$x>"html
568 [Substitutions] expr-sub echo $[42 + a[i]]
569 expr-splice echo @[split(x)]
570 var-splice @myarray @ARGV
571 command-sub @(split command)
572 [Formatting] X ysh-printf ${x %.3f}
573 X ysh-format ${x|html}
574)zZXx");
575
576GLOBAL_STR(gStr32, R"zZXx(
577 YSH Command Language Keywords <a class="group-link" href="chap-ysh-cmd.html">ysh-cmd</a>
578
579
580 [Assignment] const var Declare variables
581 setvar setvar a[i] = 42
582 setglobal setglobal d.key = 'foo'
583 [Expression] equal = = 1 + 2*3
584 call call mylist->append(42)
585 [Definitions] proc proc p (s, ...rest) {
586 typed proc p (; typed, ...rest; n=0; b) {
587 func func f(x; opt1, opt2) { return (x + 1) }
588 ysh-return return (myexpr)
589)zZXx");
590
591GLOBAL_STR(gStr33, R"zZXx(# args.ysh
592#
593# Usage:
594# source --builtin args.sh
595#
596# parser (&spec) {
597# flag -v --verbose (help="Verbosely") # default is Bool, false
598#
599# flag -P --max-procs ('int', default=-1, doc='''
600# Run at most P processes at a time
601# ''')
602#
603# flag -i --invert ('bool', default=true, doc='''
604# Long multiline
605# Description
606# ''')
607#
608# arg src (help='Source')
609# arg dest (help='Dest')
610# arg times (help='Foo')
611#
612# rest files
613# }
614#
615# var args = parseArgs(spec, ARGV)
616#
617# echo "Verbose $[args.verbose]"
618
619# TODO: See list
620# - It would be nice to keep `flag` and `arg` private, injecting them into the
621# proc namespace only within `Args`
622# - We need "type object" to replace the strings 'int', 'bool', etc.
623# - flag builtin:
624# - handle only long flag or only short flag
625# - flag aliases
626
627proc parser (; place ; ; block_def) {
628 ## Create an args spec which can be passed to parseArgs.
629 ##
630 ## Example:
631 ##
632 ## # NOTE: &spec will create a variable named spec
633 ## parser (&spec) {
634 ## flag -v --verbose ('bool')
635 ## }
636 ##
637 ## var args = parseArgs(spec, ARGV)
638
639 var p = {flags: [], args: []}
640 ctx push (p; ; block_def)
641
642 # Validate that p.rest = [name] or null and reduce p.rest into name or null.
643 if ('rest' in p) {
644 if (len(p.rest) > 1) {
645 error '`rest` was called more than once' (code=3)
646 } else {
647 setvar p.rest = p.rest[0]
648 }
649 } else {
650 setvar p.rest = null
651 }
652
653 var names = {}
654 for items in ([p.flags, p.args]) {
655 for x in (items) {
656 if (x.name in names) {
657 error "Duplicate flag/arg name $[x.name] in spec" (code=3)
658 }
659
660 setvar names[x.name] = null
661 }
662 }
663
664 # TODO: what about `flag --name` and then `arg name`?
665
666 call place->setValue(p)
667}
668
669proc flag (short, long ; type='bool' ; default=null, help=null) {
670 ## Declare a flag within an `arg-parse`.
671 ##
672 ## Examples:
673 ##
674 ## arg-parse (&spec) {
675 ## flag -v --verbose
676 ## flag -n --count ('int', default=1)
677 ## flag -f --file ('str', help="File to process")
678 ## }
679
680 # bool has a default of false, not null
681 if (type === 'bool' and default === null) {
682 setvar default = false
683 }
684
685 # TODO: validate `type`
686
687 # TODO: Should use "trimPrefix"
688 var name = long[2:]
689
690 ctx emit flags ({short, long, name, type, default, help})
691}
692
693proc arg (name ; ; help=null) {
694 ## Declare a positional argument within an `arg-parse`.
695 ##
696 ## Examples:
697 ##
698 ## arg-parse (&spec) {
699 ## arg name
700 ## arg config (help="config file path")
701 ## }
702
703 ctx emit args ({name, help})
704}
705
706proc rest (name) {
707 ## Take the remaining positional arguments within an `arg-parse`.
708 ##
709 ## Examples:
710 ##
711 ## arg-parse (&grepSpec) {
712 ## arg query
713 ## rest files
714 ## }
715
716 # We emit instead of set to detect multiple invocations of "rest"
717 ctx emit rest (name)
718}
719
720func parseArgs(spec, argv) {
721 ## Given a spec created by `parser`. Parse an array of strings `argv` per
722 ## that spec.
723 ##
724 ## See `parser` for examples of use.
725
726 var i = 0
727 var positionalPos = 0
728 var argc = len(argv)
729 var args = {}
730 var rest = []
731
732 var value
733 var found
734 while (i < argc) {
735 var arg = argv[i]
736 if (arg->startsWith('-')) {
737 setvar found = false
738
739 for flag in (spec.flags) {
740 if ( (flag.short and flag.short === arg) or
741 (flag.long and flag.long === arg) ) {
742 case (flag.type) {
743 ('bool') | (null) { setvar value = true }
744 int {
745 setvar i += 1
746 if (i >= len(argv)) {
747 error "Expected integer after '$arg'" (code=2)
748 }
749
750 try { setvar value = int(argv[i]) }
751 if (_status !== 0) {
752 error "Expected integer after '$arg', got '$[argv[i]]'" (code=2)
753 }
754 }
755 }
756
757 setvar args[flag.name] = value
758 setvar found = true
759 break
760 }
761 }
762
763 if (not found) {
764 error "Unknown flag '$arg'" (code=2)
765 }
766 } elif (positionalPos >= len(spec.args)) {
767 if (not spec.rest) {
768 error "Too many arguments, unexpected '$arg'" (code=2)
769 }
770
771 call rest->append(arg)
772 } else {
773 var pos = spec.args[positionalPos]
774 setvar positionalPos += 1
775 setvar value = arg
776 setvar args[pos.name] = value
777 }
778
779 setvar i += 1
780 }
781
782 if (spec.rest) {
783 setvar args[spec.rest] = rest
784 }
785
786 # Set defaults for flags
787 for flag in (spec.flags) {
788 if (flag.name not in args) {
789 setvar args[flag.name] = flag.default
790 }
791 }
792
793 # Raise error on missing args
794 for arg in (spec.args) {
795 if (arg.name not in args) {
796 error "Usage Error: Missing required argument $[arg.name]" (code=2)
797 }
798 }
799
800 return (args)
801}
802)zZXx");
803
804GLOBAL_STR(gStr34, R"zZXx(func identity(x) {
805 ## The identity function. Returns its argument.
806
807 return (x)
808}
809)zZXx");
810
811GLOBAL_STR(gStr35, R"zZXx(func any(list) {
812 ## Returns true if any value in the list is truthy.
813 ##
814 ## If the list is empty, return false.
815
816 for item in (list) {
817 if (item) {
818 return (true)
819 }
820 }
821 return (false)
822}
823
824func all(list) {
825 ## Returns true if all values in the list are truthy.
826 ##
827 ## If the list is empty, return true.
828
829 for item in (list) {
830 if (not item) {
831 return (false)
832 }
833 }
834 return (true)
835}
836
837func sum(list; start=0) {
838 ## Computes the sum of all elements in the list.
839 ##
840 ## Returns 0 for an empty list.
841
842 var sum = start
843 for item in (list) {
844 setvar sum += item
845 }
846 return (sum)
847}
848)zZXx");
849
850GLOBAL_STR(gStr36, R"zZXx(func __math_select(list, cmp) {
851 ## Internal helper for `max` and `min`.
852 ##
853 ## NOTE: If `list` is empty, then an error is thrown.
854
855 if (len(list) === 0) {
856 error "Unexpected empty list" (code=3)
857 }
858
859 if (len(list) === 1) {
860 return (list[0])
861 }
862
863 var match = list[0]
864 for i in (1 .. len(list)) {
865 setvar match = cmp(list[i], match)
866 }
867 return (match)
868}
869
870func max(...args) {
871 ## Compute the maximum of 2 or more values.
872 ##
873 ## `max` takes two different signatures:
874 ## - `max(a, b)` to return the maximum of `a`, `b`
875 ## - `max(list)` to return the greatest item in the `list`
876 ##
877 ## So, for example:
878 ##
879 ## max(1, 2) # => 2
880 ## max([1, 2, 3]) # => 3
881
882 case (len(args)) {
883 (1) { return (__math_select(args[0], max)) }
884 (2) {
885 if (args[0] > args[1]) {
886 return (args[0])
887 } else {
888 return (args[1])
889 }
890 }
891 (else) { error "max expects 1 or 2 args" (code=3) }
892 }
893}
894
895func min(...args) {
896 ## Compute the minimum of 2 or more values.
897 ##
898 ## `min` takes two different signatures:
899 ## - `min(a, b)` to return the minimum of `a`, `b`
900 ## - `min(list)` to return the least item in the `list`
901 ##
902 ## So, for example:
903 ##
904 ## min(2, 3) # => 2
905 ## max([1, 2, 3]) # => 1
906
907 case (len(args)) {
908 (1) { return (__math_select(args[0], min)) }
909 (2) {
910 if (args[0] < args[1]) {
911 return (args[0])
912 } else {
913 return (args[1])
914 }
915 }
916 (else) { error "min expects 1 or 2 args" (code=3) }
917 }
918}
919
920func abs(x) {
921 ## Compute the absolute (positive) value of a number (float or int).
922
923 if (x < 0) {
924 return (-x)
925 } else {
926 return (x)
927 }
928}
929)zZXx");
930
931GLOBAL_STR(gStr37, R"zZXx(# Can we define methods in pure YSH?
932#
933# (mylist->find(42) !== -1)
934#
935# instead of
936#
937# ('42' in mylist)
938#
939# Because 'in' is for Dict
940
941func find (haystack List, needle) {
942 for i, x in (haystack) {
943 if (x === needle) {
944 return (i)
945 }
946 }
947 return (-1)
948}
949)zZXx");
950
951GLOBAL_STR(gStr38, R"zZXx(# Bash strict mode, updated for 2024
952
953set -o nounset
954set -o pipefail
955set -o errexit
956shopt -s inherit_errexit
957shopt -s strict:all 2>/dev/null || true # dogfood for OSH
958
959)zZXx");
960
961GLOBAL_STR(gStr39, R"zZXx(# Library to turn a shell file into a "BYO test server"
962#
963# Usage:
964#
965# # from both bash and OSH
966# if test -z "$LIB_OSH"; then LIB_OSH=stdlib/osh; fi
967# source $LIB_OSH/byo-server-lib.sh
968#
969# The client creates a clean process state and directory state for each tests.
970#
971# (This file requires compgen -A, and maybe declare -f, so it's not POSIX
972# shell.)
973
974# TODO: How do I get stdlib/two.sh
975log() {
976 echo "$@" >& 2
977}
978
979die() {
980 log "$0: fatal: $@"
981 exit 1
982}
983
984byo-maybe-run() {
985 local command=${BYO_COMMAND:-}
986
987 case $command in
988 '')
989 # Do nothing if it's not specified
990 return
991 ;;
992
993 detect)
994 # all the commands supported, except 'detect'
995 echo list-tests
996 echo run-test
997
998 exit 66 # ASCII code for 'B' - what the protocol specifies
999 ;;
1000
1001 list-tests)
1002 # bash extension that OSH also implements
1003 compgen -A function | grep '^test-'
1004 exit 0
1005 ;;
1006
1007 run-test)
1008 local test_name=${BYO_ARG:-}
1009 if test -z "$test_name"; then
1010 die "BYO run-test: Expected BYO_ARG"
1011 fi
1012
1013 # Shell convention: we name functions test-*
1014 $test_name
1015
1016 # Only run if not set -e. Either way it's equivalent
1017 exit $?
1018 ;;
1019
1020 *)
1021 die "Invalid BYO command '$command'"
1022 ;;
1023 esac
1024
1025 # Do nothing if BYO_COMMAND is not set.
1026 # The program continues to its "main".
1027}
1028
1029byo-must-run() {
1030 local command=${BYO_COMMAND:-}
1031 if test -z "$command"; then
1032 die "Expected BYO_COMMAND= in environment"
1033 fi
1034
1035 byo-maybe-run
1036}
1037)zZXx");
1038
1039GLOBAL_STR(gStr40, R"zZXx(#!/usr/bin/env bash
1040#
1041# Testing library for bash and OSH.
1042#
1043# Capture status/stdout/stderr, and nq-assert those values.
1044
1045: ${LIB_OSH=stdlib/osh}
1046source $LIB_OSH/two.sh
1047
1048nq-assert() {
1049 ### Assertion with same syntax as shell 'test'
1050
1051 if ! test "$@"; then
1052 die "line ${BASH_LINENO[0]}: nq-assert $(printf '%q ' "$@") failed"
1053 fi
1054}
1055
1056# Problem: we want to capture status and stdout at the same time
1057#
1058# We use:
1059#
1060# __stdout=$(set -o errexit; "$@")
1061# __status=$?
1062#
1063# However, we lose the trailing \n, since that's how command subs work.
1064
1065# Here is another possibility:
1066#
1067# shopt -s lastpipe # need this too
1068# ( set -o errexit; "$@" ) | read -r -d __stdout
1069# __status=${PIPESTATUS[0]}
1070# shopt -u lastpipe
1071#
1072# But this feels complex for just the \n issue, which can be easily worked
1073# around.
1074
1075nq-run() {
1076 ### capture status only
1077
1078 local -n out_status=$1
1079 shift
1080
1081 local __status
1082
1083 # Tricky: turn errexit off so we can capture it, but turn it on against
1084 set +o errexit
1085 ( set -o errexit; "$@" )
1086 __status=$?
1087 set -o errexit
1088
1089 out_status=$__status
1090}
1091
1092nq-capture() {
1093 ### capture status and stdout
1094
1095 local -n out_status=$1
1096 local -n out_stdout=$2
1097 shift 2
1098
1099 local __status
1100 local __stdout
1101
1102 # Tricky: turn errexit off so we can capture it, but turn it on against
1103 set +o errexit
1104 __stdout=$(set -o errexit; "$@")
1105 __status=$?
1106 set -o errexit
1107
1108 out_status=$__status
1109 out_stdout=$__stdout
1110}
1111
1112nq-capture-2() {
1113 ### capture status and stderr
1114
1115 # This is almost identical to the above
1116
1117 local -n out_status=$1
1118 local -n out_stderr=$2
1119 shift 2
1120
1121 local __status
1122 local __stderr
1123
1124 # Tricky: turn errexit off so we can capture it, but turn it on against
1125 set +o errexit
1126 __stderr=$(set -o errexit; "$@" 2>&1)
1127 __status=$?
1128 set -o errexit
1129
1130 out_status=$__status
1131 out_stderr=$__stderr
1132}
1133
1134_demo-stderr() {
1135 echo zzz "$@" >& 2
1136 return 99
1137}
1138
1139test-nq-capture() {
1140 local status stdout
1141 nq-capture status stdout \
1142 echo -n hi
1143 nq-assert 0 = "$status"
1144 nq-assert 'hi' = "$stdout"
1145
1146 nq-capture status stdout \
1147 echo hi
1148 nq-assert 0 = "$status"
1149 # Note that we LOSE the last newline!
1150 #nq-assert $'hi\n' = "$stdout"
1151
1152 local stderr
1153 nq-capture-2 status stderr \
1154 _demo-stderr yyy
1155
1156 #echo "stderr: [$stderr]"
1157
1158 nq-assert 99 = "$status"
1159 nq-assert 'zzz yyy' = "$stderr"
1160
1161 nq-capture status stdout \
1162 _demo-stderr aaa
1163
1164 #echo "stderr: [$stderr]"
1165
1166 nq-assert 99 = "$status"
1167 nq-assert '' = "$stdout"
1168}
1169
1170name=$(basename $0)
1171if test "$name" = 'no-quotes.sh'; then
1172 "$@"
1173fi
1174)zZXx");
1175
1176GLOBAL_STR(gStr41, R"zZXx(#!/usr/bin/env bash
1177#
1178# Common shell functions for task scripts.
1179#
1180# Usage:
1181# source $LIB_OSH/task-five.sh
1182#
1183# test-foo() { # define task functions
1184# echo foo
1185# }
1186# task-five "$@"
1187
1188# Definition of a "task"
1189#
1190# - File invokes task-five "$@"
1191# - or maybe you can look at its source
1192# - It's a shell function
1193# - Has ### docstring
1194# - Doesn't start with _
1195
1196: ${LIB_OSH=stdlib/osh}
1197source $LIB_OSH/byo-server.sh
1198
1199
1200# List all functions defined in this file (and not in sourced files).
1201_bash-print-funcs() {
1202 ### Print shell functions in this file that don't start with _ (bash reflection)
1203
1204 local funcs
1205 funcs=($(compgen -A function))
1206 # extdebug makes `declare -F` print the file path, but, annoyingly, only
1207 # if you pass the function names as arguments.
1208 shopt -s extdebug
1209 declare -F "${funcs[@]}" | grep --fixed-strings " $0" | awk '{print $1}'
1210 shopt -u extdebug
1211}
1212
1213_awk-print-funcs() {
1214 ### Print shell functions in this file that don't start with _ (awk parsing)
1215
1216 # Using gawk because it has match()
1217 # - doesn't start with _
1218
1219 # space = / ' '* /
1220 # shfunc = / %begin
1221 # <capture !['_' ' '] ![' ']*>
1222 # '()' space '{' space
1223 # %end /
1224 # docstring = / %begin
1225 # space '###' ' '+
1226 # <capture dot*>
1227 # %end /
1228 awk '
1229 match($0, /^([^_ ][^ ]*)\(\)[ ]*{[ ]*$/, m) {
1230 print NR " shfunc " m[1]
1231 #print m[0]
1232 }
1233
1234 match($0, /^[ ]*###[ ]+(.*)$/, m) {
1235 print NR " docstring " m[1]
1236 }
1237' $0
1238}
1239
1240_show-help() {
1241 # TODO:
1242 # - Use awk to find comments at the top of the file?
1243 # - Use OSH to extract docstrings
1244 # - BYO_COMMAND=list-tasks will reuse that logic? It only applies to the
1245 # current file, not anything in a different file?
1246
1247 echo "Usage: $0 TASK_NAME ARGS..."
1248 echo
1249 echo "To complete tasks, run:"
1250 echo " source devtools/completion.bash"
1251 echo
1252 echo "Tasks:"
1253
1254 if command -v column >/dev/null; then
1255 _bash-print-funcs | column
1256 else
1257 _bash-print-funcs
1258 fi
1259}
1260
1261task-five() {
1262 # Respond to BYO_COMMAND=list-tasks, etc. All task files need this.
1263 byo-maybe-run
1264
1265 case ${1:-} in
1266 ''|--help|-h)
1267 _show-help
1268 exit 0
1269 ;;
1270 esac
1271
1272 if ! declare -f "$1" >/dev/null; then
1273 echo "$0: '$1' isn't an action in this task file. Try '$0 --help'"
1274 exit 1
1275 fi
1276
1277 "$@"
1278}
1279)zZXx");
1280
1281GLOBAL_STR(gStr42, R"zZXx(# Two functions I actually use, all the time.
1282#
1283# To keep depenedencies small, this library will NEVER grow other functions
1284# (and is named to imply that.)
1285#
1286# Usage:
1287# source --builtin two.sh
1288#
1289# Examples:
1290# log 'hi'
1291# die 'expected a number'
1292
1293log() {
1294 ### Write a message to stderr.
1295 echo "$@" >&2
1296}
1297
1298die() {
1299 ### Write an error message with the script name, and exit with status 1.
1300 log "$0: fatal: $@"
1301 exit 1
1302}
1303
1304)zZXx");
1305
1306GLOBAL_STR(gStr43, R"zZXx(# These were helpful while implementing args.ysh
1307# Maybe we will want to export them in a prelude so that others can use them too?
1308#
1309# Prior art: Rust has `todo!()` which is quite nice. Other languages allow
1310# users to `raise NotImplmentedError()`.
1311
1312# Andy comments:
1313# - 'pass' can be : or true in shell. It's a little obscure / confusing, but
1314# there is an argument for minimalism. Although I prefer words like 'true',
1315# and that already means something.
1316# - UPDATE: we once took 'pass' as a keyword, but users complained because
1317# there is a command 'pass'. So we probably can't have this by default.
1318# Need to discuss source --builtin.
1319
1320# - todo could be more static? Rust presumably does it at compile time
1321
1322proc todo () {
1323 ## Raises a not implemented error when run.
1324 error ("TODO: not implemented") # TODO: is error code 1 ok?
1325}
1326
1327proc pass () {
1328 ## Use when you want to temporarily leave a block empty.
1329 _ null
1330}
1331)zZXx");
1332
1333GLOBAL_STR(gStr44, R"zZXx(# stream.ysh
1334#
1335# Usage:
1336# source --builtin stream.ysh
1337#
1338# For reading lines, decoding, extracting, splitting
1339
1340# make this file a test server
1341source --builtin osh/byo-server.sh
1342
1343source --builtin args.ysh
1344
1345proc slurp-by (; num_lines) {
1346 # TODO: (stdin)
1347 for line in <> {
1348 echo TODO
1349 }
1350}
1351
1352# Note:
1353# - these are all the same algorithm
1354# - also word, block, etc. are all optional
1355
1356proc each-line (...words; template=null; ; block=null) {
1357 # TODO:
1358 # parse --j8 --max-jobs flag
1359
1360 # parse template_str as string
1361 # TODO: this is dangerous though ... because you can execute code
1362 # I think you need a SAFE version
1363
1364 # evaluate template string expression - I guess that allows $(echo hi) and so
1365 # forth
1366
1367 # evaluate block with _line binding
1368 # block: execute in parallel with --max-jobs
1369
1370 for line in <> {
1371 echo TODO
1372 }
1373}
1374
1375proc test-each-line {
1376 echo 'TODO: need basic test runner'
1377
1378 # ysh-tool test stream.ysh
1379 #
1380 # Col
1381
1382
1383}
1384
1385proc each-row (; ; block) {
1386 echo TODO
1387}
1388
1389proc split-by (; ifs=null; block) {
1390 echo TODO
1391}
1392
1393proc if-split-by (; ifs=null; block) {
1394 echo TODO
1395}
1396
1397proc chop () {
1398 ### alias for if-split-by
1399 echo TODO
1400}
1401
1402proc must-match (; pattern; block) {
1403 echo TODO
1404}
1405
1406proc if-match (; pattern; block) {
1407 echo TODO
1408}
1409
1410# Protocol:
1411#
1412# - The file lists its tests the "actions"
1413# - Then the test harness runs them
1414# - But should it be ENV vars
1415#
1416# - BYO_LIST_TESTS=1
1417# - BYO_RUN_TEST=foo
1418# - $PWD is a CLEAN temp dir, the process doesn't have to do anything
1419
1420# - silent on success, but prints file on output
1421# - OK this makes sense
1422#
1423# The trivial test in Python:
1424#
1425# from test import byo
1426# byo.maybe_main()
1427#
1428# bash library:
1429# source --builtin byo-server.sh
1430#
1431# byo-maybe-main # reads env variables, and then exits
1432#
1433# source --builtin assertions.ysh
1434#
1435# assert-ok 'echo hi'
1436# assert-stdout 'hi' 'echo -n hi'
1437#
1438# "$@"
1439#
1440# Run all tests
1441# util/byo-client.sh run-tests $YSH stdlib/table.ysh
1442# util/byo-client.sh run-tests -f x $YSH stdlib/table.ysh
1443
1444# Clean process
1445# Clean working dir
1446
1447#
1448# Stream Protocol:
1449# #.byo - is this she-dot, that's for a file
1450# Do we need metadata?
1451#
1452
1453# The harness
1454#
1455# It's process based testing.
1456#
1457# Test runner process: bash or OSH (unlike sharness!)
1458# Tested process: any language - bash,
1459#
1460# Key point: you don't have to quote shell code?
1461
1462list-byo-tests() {
1463 echo TODO
1464}
1465
1466run-byo-tests() {
1467 # source it
1468 echo TODO
1469}
1470
1471byo-maybe-run
1472)zZXx");
1473
1474GLOBAL_STR(gStr45, R"zZXx(# table.ysh - Library for tables.
1475#
1476# Usage:
1477# source --builtin table.ysh
1478
1479# make this file a test server
1480source --builtin osh/byo-server.sh
1481
1482proc table (...words; place; ; block) {
1483 var n = len(words)
1484
1485 # TODO: parse flags
1486 #
1487 # --by-row
1488 # --by-col
1489 #
1490 # Place is optional
1491
1492 if (n === 0) {
1493 echo TODO
1494 return
1495 }
1496
1497 var action = words[0]
1498
1499 # textual operations
1500 case (action) {
1501 cat {
1502 echo todo
1503 }
1504 align {
1505 echo todo
1506 }
1507 tabify {
1508 echo todo
1509 }
1510 tabify {
1511 echo todo
1512 }
1513 header {
1514 echo todo
1515 }
1516 slice {
1517 # this has typed args
1518 # do we do some sort of splat?
1519 echo todo
1520 }
1521 to-tsv {
1522 echo todo
1523 }
1524 }
1525
1526 echo TODO
1527}
1528
1529proc test-table {
1530 return
1531
1532 table (&files1) {
1533 cols num_bytes path
1534 type Int Str
1535
1536 row 10 README.md
1537 row 12 main.py
1538
1539 row (12, 'lib.py')
1540 row (num_bytes=12, path='util.py')
1541 }
1542
1543 # 2 columns - The default is by column?
1544 assert ['Dict' === type(files1)]
1545 assert [2 === len(files1)]
1546
1547 # Same table
1548 table --by-row (&files2) {
1549 cols num_bytes path
1550 type Int Str
1551
1552 row 10 README.md
1553 row 12 main.py
1554
1555 row (12, 'lib.py')
1556 row (num_bytes=12, path='util.py')
1557 }
1558
1559 # 4 rows
1560 assert ['List' === type(files2)]
1561 assert [4 === len(files2)]
1562}
1563
1564# "subcommands" of the dialect
1565
1566proc cols (...names) {
1567 # cols name age
1568 echo TODO
1569}
1570
1571proc types (...types) {
1572 # types - Int? Str?
1573 echo TODO
1574}
1575
1576proc attr (name; ...values) {
1577 # attr units ('-', 'secs')
1578 echo TODO
1579}
1580
1581# is this allowed outside table {} blocks too?
1582proc row {
1583 echo TODO
1584}
1585
1586#
1587# dplyr names
1588#
1589
1590# TODO: can we parse select?
1591
1592proc where {
1593 echo
1594}
1595
1596# TODO: should be able to test argv[0] or something
1597# Or pass to _mutate-transmute
1598
1599proc mutate {
1600 echo TODO
1601}
1602
1603proc transmute {
1604 echo TODO
1605}
1606
1607proc rename {
1608 echo TODO
1609}
1610
1611proc group-by {
1612 echo TODO
1613}
1614
1615proc sort-by {
1616 echo TODO
1617}
1618
1619proc summary {
1620 echo TODO
1621}
1622
1623byo-maybe-run
1624)zZXx");
1625
1626GLOBAL_STR(gStr46, R"zZXx(# testing.ysh
1627#
1628# Usage:
1629# source --builtin testing.sh
1630#
1631# func f(x) { return (x + 1) }
1632#
1633# describe foo {
1634# assert (43 === f(42))
1635# }
1636#
1637# if is-main {
1638# run-tests @ARGV # --filter
1639# }
1640
1641module stdlib/testing || return 0
1642
1643source --builtin args.ysh
1644
1645proc assert ( ; cond ; fail_message='default fail message') {
1646 echo 'hi from assert'
1647
1648 = cond
1649
1650 # I think this might be ready now?
1651
1652 var val = evalExpr(cond)
1653
1654 echo
1655 echo 'value'
1656 = val
1657 pp line (val)
1658
1659 = fail_message
1660
1661 if (val) {
1662 echo 'OK'
1663 } else {
1664 var m = evalExpr(fail_message)
1665 echo "FAIL - this is where we extract the string - $m"
1666 }
1667}
1668
1669proc test-assert {
1670 var x = 42
1671 assert [42 === x]
1672}
1673
1674proc test-expr ( ; expr ) {
1675 echo 'expr'
1676 pp line (expr)
1677}
1678
1679proc test-named ( ; ; n=^[99] ) {
1680 echo 'n'
1681 pp line (n)
1682}
1683
1684# What happens when there are duplicate test IDs?
1685#
1686# Also I think filter by "$test_id/$case_id"
1687
1688proc __it (case_id ; ; ; block) {
1689 # This uses a clean directory
1690 echo TODO
1691}
1692
1693# is this accessible to users?
1694# It can contain a global list of things to run
1695
1696# Naming convention: a proc named 'describe' mutates a global named _describe?
1697# Or maybe _describe_list ?
1698
1699var _describe_list = []
1700
1701proc describe (test_id ; ; ; block) {
1702 echo describe
1703 #= desc
1704
1705 # TODO:
1706 # - need append
1707 # - need ::
1708 # _ _describe->append(cmd)
1709 #
1710 # Need to clean this up
1711 # append (_describe, cmd) # does NOT work!
1712
1713 call _describe_list->append(block)
1714}
1715
1716proc Args {
1717 echo TODO
1718}
1719
1720# Problem: this creates a global variable?
1721Args (&spec) {
1722 flag --filter 'Regex of test descriptions'
1723}
1724
1725proc run-tests {
1726 var opt, i = parseArgs(spec, ARGV)
1727
1728 # TODO:
1729 # - parse --filter foo, which you can use eggex for!
1730
1731 for cmd in (_describe) {
1732 # TODO: print filename and 'describe' name?
1733 try {
1734 eval (cmd)
1735 }
1736 if (_status !== 0) {
1737 echo 'failed'
1738 }
1739 }
1740}
1741)zZXx");
1742
1743
1744
1745TextFile array[] = {
1746 {.rel_path = "_devbuild/help/data-errors", .contents = gStr0},
1747 {.rel_path = "_devbuild/help/data-front-end", .contents = gStr1},
1748 {.rel_path = "_devbuild/help/data-j8-notation", .contents = gStr2},
1749 {.rel_path = "_devbuild/help/help", .contents = gStr3},
1750 {.rel_path = "_devbuild/help/oils-usage", .contents = gStr4},
1751 {.rel_path = "_devbuild/help/osh-builtin-cmd", .contents = gStr5},
1752 {.rel_path = "_devbuild/help/osh-chapters", .contents = gStr6},
1753 {.rel_path = "_devbuild/help/osh-cmd-lang", .contents = gStr7},
1754 {.rel_path = "_devbuild/help/osh-front-end", .contents = gStr8},
1755 {.rel_path = "_devbuild/help/osh-mini-lang", .contents = gStr9},
1756 {.rel_path = "_devbuild/help/osh-option", .contents = gStr10},
1757 {.rel_path = "_devbuild/help/osh-osh-assign", .contents = gStr11},
1758 {.rel_path = "_devbuild/help/osh-plugin", .contents = gStr12},
1759 {.rel_path = "_devbuild/help/osh-special-var", .contents = gStr13},
1760 {.rel_path = "_devbuild/help/osh-stdlib", .contents = gStr14},
1761 {.rel_path = "_devbuild/help/osh-type-method", .contents = gStr15},
1762 {.rel_path = "_devbuild/help/osh-usage", .contents = gStr16},
1763 {.rel_path = "_devbuild/help/osh-word-lang", .contents = gStr17},
1764 {.rel_path = "_devbuild/help/ysh-builtin-cmd", .contents = gStr18},
1765 {.rel_path = "_devbuild/help/ysh-builtin-func", .contents = gStr19},
1766 {.rel_path = "_devbuild/help/ysh-chapters", .contents = gStr20},
1767 {.rel_path = "_devbuild/help/ysh-cmd-lang", .contents = gStr21},
1768 {.rel_path = "_devbuild/help/ysh-expr-lang", .contents = gStr22},
1769 {.rel_path = "_devbuild/help/ysh-front-end", .contents = gStr23},
1770 {.rel_path = "_devbuild/help/ysh-mini-lang", .contents = gStr24},
1771 {.rel_path = "_devbuild/help/ysh-option", .contents = gStr25},
1772 {.rel_path = "_devbuild/help/ysh-plugin", .contents = gStr26},
1773 {.rel_path = "_devbuild/help/ysh-special-var", .contents = gStr27},
1774 {.rel_path = "_devbuild/help/ysh-stdlib", .contents = gStr28},
1775 {.rel_path = "_devbuild/help/ysh-type-method", .contents = gStr29},
1776 {.rel_path = "_devbuild/help/ysh-usage", .contents = gStr30},
1777 {.rel_path = "_devbuild/help/ysh-word-lang", .contents = gStr31},
1778 {.rel_path = "_devbuild/help/ysh-ysh-cmd", .contents = gStr32},
1779 {.rel_path = "stdlib/args.ysh", .contents = gStr33},
1780 {.rel_path = "stdlib/funcs.ysh", .contents = gStr34},
1781 {.rel_path = "stdlib/list.ysh", .contents = gStr35},
1782 {.rel_path = "stdlib/math.ysh", .contents = gStr36},
1783 {.rel_path = "stdlib/methods.ysh", .contents = gStr37},
1784 {.rel_path = "stdlib/osh/bash-strict.sh", .contents = gStr38},
1785 {.rel_path = "stdlib/osh/byo-server.sh", .contents = gStr39},
1786 {.rel_path = "stdlib/osh/no-quotes.sh", .contents = gStr40},
1787 {.rel_path = "stdlib/osh/task-five.sh", .contents = gStr41},
1788 {.rel_path = "stdlib/osh/two.sh", .contents = gStr42},
1789 {.rel_path = "stdlib/prelude.ysh", .contents = gStr43},
1790 {.rel_path = "stdlib/stream.ysh", .contents = gStr44},
1791 {.rel_path = "stdlib/table.ysh", .contents = gStr45},
1792 {.rel_path = "stdlib/testing.ysh", .contents = gStr46},
1793
1794 {.rel_path = nullptr, .contents = nullptr},
1795};
1796
1797} // namespace embedded_file
1798
1799TextFile* gEmbeddedFiles = embedded_file::array; // turn array into pointer